#Copyright (c) 2008 Vincent Povirk
#
#Permission is hereby granted, free of charge, to any person
#obtaining a copy of this software and associated documentation
#files (the "Software"), to deal in the Software without
#restriction, including without limitation the rights to use,
#copy, modify, merge, publish, distribute, sublicense, and/or sell
#copies of the Software, and to permit persons to whom the
#Software is furnished to do so, subject to the following
#conditions:
#
#The above copyright notice and this permission notice shall be
#included in all copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
#EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
#OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
#NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
#HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
#WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
#OTHER DEALINGS IN THE SOFTWARE.

# Message definitions
# see http://msdn.microsoft.com/en-us/library/ms632590(VS.85).aspx

from ctypes import windll, Structure, POINTER, WINFUNCTYPE, byref
from winlitecfg import get_aw_symbols
from winliteutils import get_symbols, NONZERO
from windef import UINT, HDESK, HWND, LUID, WPARAM, LPARAM, DWORD, POINT, ULONG_PTR, LRESULT, LPDWORD, LONG, BOOL, LPVOID, INT, LPCTSTR, PDWORD_PTR

BSF_QUERY = 0x00000001
BSF_IGNORECURRENTTASK = 0x00000002
BSF_FLUSHDISK = 0x00000004
BSF_NOHANG = 0x00000008
BSF_POSTMESSAGE = 0x00000010
BSF_FORCEIFHUNG = 0x00000020
BSF_NOTIMEOUTIFNOTHUNG = 0x00000040
BSF_ALLOWSFW = 0x00000080
BSF_SENDNOTIFYMESSAGE = 0x00000100
BSF_RETURNHDESK = 0x00000200
BSF_LUID = 0x00000400

BSM_ALLCOMPONENTS = 0x00000000
BSM_VXDS = 0x00000001
BSM_NETDRIVER = 0x00000002
BSM_INSTALLABLEDRIVERS = 0x00000004
BSM_APPLICATIONS = 0x00000008
BSM_ALLDESKTOPS = 0x00000010

QS_KEY = 0x0001
QS_MOUSEMOVE = 0x0002
QS_MOUSEBUTTON = 0x0004
QS_MOUSE = (QS_MOUSEMOVE | QS_MOUSEBUTTON)
QS_POSTMESSAGE = 0x0008
QS_TIMER = 0x0010
QS_PAINT = 0x0020
QS_SENDMESSAGE = 0x0040
QS_HOTKEY = 0x0080
QS_ALLPOSTMESSAGE = 0x0100
QS_RAWINPUT = 0x0400
QS_INPUT = (QS_MOUSE | QS_KEY | QS_RAWINPUT)
QS_ALLEVENTS = (QS_INPUT | QS_POSTMESSAGE | QS_TIMER | QS_PAINT | QS_HOTKEY)
QS_ALLINPUT = (QS_ALLEVENTS | QS_SENDMESSAGE)

ISMEX_NOSEND = 0x00000000
ISMEX_SEND = 0x00000001
ISMEX_NOTIFY = 0x00000002
ISMEX_CALLBACK = 0x00000004
ISMEX_REPLIED = 0x00000008

PM_NOREMOVE = 0x0000
PM_REMOVE = 0x0001
PM_NOYIELD = 0x0002
PM_QS_INPUT = (QS_INPUT << 16)
PM_QS_POSTMESSAGE = ((QS_POSTMESSAGE | QS_HOTKEY | QS_TIMER) << 16)
PM_QS_PAINT = (QS_PAINT << 16)
PM_QS_SENDMESSAGE = (QS_SENDMESSAGE << 16)

HWND_BROADCAST = 0xFFFF

SMTO_NORMAL = 0x0000
SMTO_BLOCK = 0x0001
SMTO_ABORTIFHUNG = 0x0002
SMTO_NOTIMEOUTIFNOTHUNG = 0x0008

class BSMINFO(Structure):
    _fields_ = [
        ('cbSize', UINT),
        ('hdesk', HDESK),
        ('hwnd', HWND),
        ('luid', LUID),
        ]
PBSMINFO = POINTER(BSMINFO)

class MSG(Structure):
    _fields_ = [
        ('hwnd', HWND),
        ('message', UINT),
        ('wParam', WPARAM),
        ('lParam', LPARAM),
        ('time', DWORD),
        ('pt', POINT),
        ]
LPMSG = PMSG = POINTER(MSG)

SENDASYNCPROC = WINFUNCTYPE(None, HWND, UINT, ULONG_PTR, LRESULT)

get_aw_symbols(globals(), windll.user32, ['BroadcastSystemMessage', 'BroadcastSystemMessageEx', 'DispatchMessage', 'GetMessage', 'PeekMessage', 'PostMessage', 'PostThreadMessage', 'RegisterWindowMessage', 'SendMessage', 'SendMessageCallback', 'SendMessageTimeout', 'SendNotifyMessage'])
get_symbols(globals(), windll.user32, ['GetInputState', 'GetMessageExtraInfo', 'GetMessagePos', 'GetMessageTime', 'GetQueueStatus', 'InSendMessage', 'InSendMessageEx', 'PostQuitMessage', 'ReplyMessage', 'SetMessageExtraInfo', 'TranslateMessage', 'WaitMessage'])

BroadcastSystemMessage.argtypes = [DWORD, LPDWORD, UINT, WPARAM, LPARAM]
BroadcastSystemMessage.restype = LONG

BroadcastSystemMessageEx.argtypes = [DWORD, LPDWORD, UINT, WPARAM, LPARAM, PBSMINFO]
BroadcastSystemMessageEx.restype = LONG

DispatchMessage.argtypes = [LPMSG]
DispatchMessage.restype = LRESULT

GetInputState.argtypes = []
GetInputState.restype = BOOL

GetMessage.argtypes = [LPMSG, HWND, UINT, UINT]
GetMessage.restype = BOOL

GetMessageExtraInfo.argtypes = []
GetMessageExtraInfo.restype = LPARAM

GetMessagePos.argtypes = []
GetMessagePos.restype = DWORD #MAKEPOINTS

GetMessageTime.argtypes = []
GetMessageTime.restype = LONG

GetQueueStatus.argtypes = [UINT]
GetQueueStatus.restype = DWORD

InSendMessage.argtypes = []
InSendMessage.restype = BOOL

InSendMessageEx.argtypes = [LPVOID]
InSendMessageEx.restype = DWORD

PeekMessage.argtypes = [LPMSG, HWND, UINT, UINT, UINT]
PeekMessage.restype = BOOL

PostMessage.argtypes = [HWND, UINT, WPARAM, LPARAM]
PostMessage.restype = NONZERO

PostQuitMessage.argtypes = [INT]
PostQuitMessage.restype = None

PostThreadMessage.argtypes = [DWORD, UINT, WPARAM, LPARAM]
PostThreadMessage.restype = NONZERO

RegisterWindowMessage.argtypes = [LPCTSTR]
RegisterWindowMessage.restype = NONZERO

ReplyMessage.argtypes = [LRESULT]
ReplyMessage.restype = BOOL

SendMessage.argtypes = [HWND, UINT, WPARAM, LPARAM]
SendMessage.restype = LRESULT

SendMessageCallback.argtypes = [HWND, UINT, WPARAM, LPARAM, SENDASYNCPROC, ULONG_PTR]
SendMessageCallback.restype = NONZERO

SendMessageTimeout.argtypes = [HWND, UINT, WPARAM, LPARAM, UINT, UINT, PDWORD_PTR]
SendMessageTimeout.restype = LRESULT

SendNotifyMessage.argtypes = [HWND, UINT, WPARAM, LPARAM]
SendNotifyMessage.restype = NONZERO

SetMessageExtraInfo.argtypes = [LPARAM]
SetMessageExtraInfo.restype = LPARAM

TranslateMessage.argtypes = [LPMSG]
TranslateMessage.restype = BOOL

WaitMessage.argtypes = []
WaitMessage.restype = NONZERO

def loop():
    """loop() - standard windows main loop

Run a message loop until PostQuitMessage() is called, then return the integer value passed to PostQuitMessage()."""
    msg = MSG()
    while True:
        result = GetMessage(byref(msg), 0, 0, 0)
        if result == 0: #got WM_QUIT message
            return msg.wParam
        elif result == -1: #error
            raise WinError()
        TranslateMessage(byref(msg))
        DispatchMessage(byref(msg))

# Message constants
WM_NULL = 0x0000
WM_CREATE = 0x0001
WM_DESTROY = 0x0002
WM_MOVE = 0x0003
WM_SIZEWAIT = 0x0004
WM_SIZE = 0x0005
WM_ACTIVATE = 0x0006
WM_SETFOCUS = 0x0007
WM_KILLFOCUS = 0x0008
WM_SETVISIBLE = 0x0009
WM_ENABLE = 0x000a
WM_SETREDRAW = 0x000b
WM_SETTEXT = 0x000c
WM_GETTEXT = 0x000d
WM_GETTEXTLENGTH = 0x000e
WM_PAINT = 0x000f
WM_CLOSE = 0x0010
WM_QUERYENDSESSION = 0x0011
WM_QUIT = 0x0012
WM_QUERYOPEN = 0x0013
WM_ERASEBKGND = 0x0014
WM_SYSCOLORCHANGE = 0x0015
WM_ENDSESSION = 0x0016
WM_SYSTEMERROR = 0x0017
WM_SHOWWINDOW = 0x0018
WM_CTLCOLOR = 0x0019
WM_WININICHANGE = 0x001a
WM_SETTINGCHANGE = WM_WININICHANGE
WM_DEVMODECHANGE = 0x001b
WM_ACTIVATEAPP = 0x001c
WM_FONTCHANGE = 0x001d
WM_TIMECHANGE = 0x001e
WM_CANCELMODE = 0x001f
WM_SETCURSOR = 0x0020
WM_MOUSEACTIVATE = 0x0021
WM_CHILDACTIVATE = 0x0022
WM_QUEUESYNC = 0x0023
WM_GETMINMAXINFO = 0x0024
WM_PAINTICON = 0x0026
WM_ICONERASEBKGND = 0x0027
WM_NEXTDLGCTL = 0x0028
WM_ALTTABACTIVE = 0x0029
WM_SPOOLERSTATUS = 0x002a
WM_DRAWITEM = 0x002b
WM_MEASUREITEM = 0x002c
WM_DELETEITEM = 0x002d
WM_VKEYTOITEM = 0x002e
WM_CHARTOITEM = 0x002f
WM_SETFONT = 0x0030
WM_GETFONT = 0x0031
WM_SETHOTKEY = 0x0032
WM_GETHOTKEY = 0x0033
WM_FILESYSCHANGE = 0x0034
WM_ISACTIVEICON = 0x0035
WM_QUERYPARKICON = 0x0036
WM_QUERYDRAGICON = 0x0037
WM_QUERYSAVESTATE = 0x0038
WM_COMPAREITEM = 0x0039
WM_TESTING = 0x003a
WM_GETOBJECT = 0x003d
WM_ACTIVATESHELLWINDOW = 0x003e
WM_COMPACTING = 0x0041
WM_COMMNOTIFY = 0x0044
WM_WINDOWPOSCHANGING = 0x0046
WM_WINDOWPOSCHANGED = 0x0047
WM_POWER = 0x0048
WM_COPYDATA = 0x004a
WM_CANCELJOURNAL = 0x004b
WM_KEYF1 = 0x004d
WM_NOTIFY = 0x004e
WM_INPUTLANGCHANGEREQUEST = 0x0050
WM_INPUTLANGCHANGE = 0x0051
WM_TCARD = 0x0052
WM_HELP = 0x0053
WM_USERCHANGED = 0x0054
WM_NOTIFYFORMAT = 0x0055
WM_CONTEXTMENU = 0x007b
WM_STYLECHANGING = 0x007c
WM_STYLECHANGED = 0x007d
WM_DISPLAYCHANGE = 0x007e
WM_GETICON = 0x007f
WM_SETICON = 0x0080
WM_NCCREATE = 0x0081
WM_NCDESTROY = 0x0082
WM_NCCALCSIZE = 0x0083
WM_NCHITTEST = 0x0084
WM_NCPAINT = 0x0085
WM_NCACTIVATE = 0x0086
WM_GETDLGCODE = 0x0087
WM_SYNCPAINT = 0x0088
WM_SYNCTASK = 0x0089
WM_NCMOUSEMOVE = 0x00a0
WM_NCLBUTTONDOWN = 0x00a1
WM_NCLBUTTONUP = 0x00a2
WM_NCLBUTTONDBLCLK = 0x00a3
WM_NCRBUTTONDOWN = 0x00a4
WM_NCRBUTTONUP = 0x00a5
WM_NCRBUTTONDBLCLK = 0x00a6
WM_NCMBUTTONDOWN = 0x00a7
WM_NCMBUTTONUP = 0x00a8
WM_NCMBUTTONDBLCLK = 0x00a9
WM_NCXBUTTONDOWN = 0x00ab
WM_NCXBUTTONUP = 0x00ac
WM_NCXBUTTONDBLCLK = 0x00ad
WM_INPUT_DEVICE_CHANGE = 0x00fe
WM_INPUT = 0x00ff
WM_KEYDOWN = 0x0100
WM_KEYUP = 0x0101
WM_CHAR = 0x0102
WM_DEADCHAR = 0x0103
WM_SYSKEYDOWN = 0x0104
WM_SYSKEYUP = 0x0105
WM_SYSCHAR = 0x0106
WM_SYSDEADCHAR = 0x0107
WM_UNICHAR = 0x0109
WM_KEYFIRST = WM_KEYDOWN
WM_KEYLAST = 0x0109
WM_IME_STARTCOMPOSITION = 0x010d
WM_IME_ENDCOMPOSITION = 0x010e
WM_IME_COMPOSITION = 0x010f
WM_IME_KEYLAST = 0x010f
WM_INITDIALOG = 0x0110
WM_COMMAND = 0x0111
WM_SYSCOMMAND = 0x0112
WM_TIMER = 0x0113
WM_HSCROLL = 0x0114
WM_VSCROLL = 0x0115
WM_INITMENU = 0x0116
WM_INITMENUPOPUP = 0x0117
WM_MENUSELECT = 0x011F
WM_MENUCHAR = 0x0120
WM_ENTERIDLE = 0x0121
WM_MENURBUTTONUP = 0x0122
WM_MENUDRAG = 0x0123
WM_MENUGETOBJECT = 0x0124
WM_UNINITMENUPOPUP = 0x0125
WM_MENUCOMMAND = 0x0126
WM_CHANGEUISTATE = 0x0127
WM_UPDATEUISTATE = 0x0128
WM_QUERYUISTATE = 0x0129
WM_LBTRACKPOINT = 0x0131
WM_CTLCOLORMSGBOX = 0x0132
WM_CTLCOLOREDIT = 0x0133
WM_CTLCOLORLISTBOX = 0x0134
WM_CTLCOLORBTN = 0x0135
WM_CTLCOLORDLG = 0x0136
WM_CTLCOLORSCROLLBAR = 0x0137
WM_CTLCOLORSTATIC = 0x0138
WM_MOUSEMOVE = 0x0200
WM_LBUTTONDOWN = 0x0201
WM_LBUTTONUP = 0x0202
WM_LBUTTONDBLCLK = 0x0203
WM_RBUTTONDOWN = 0x0204
WM_RBUTTONUP = 0x0205
WM_RBUTTONDBLCLK = 0x0206
WM_MBUTTONDOWN = 0x0207
WM_MBUTTONUP = 0x0208
WM_MBUTTONDBLCLK = 0x0209
WM_MOUSEWHEEL = 0x020A
WM_MOUSEFIRST = 0x0200
WM_MOUSELAST = 0x020E
WM_PARENTNOTIFY = 0x0210
WM_ENTERMENULOOP = 0x0211
WM_EXITMENULOOP = 0x0212
WM_NEXTMENU = 0x0213
WM_SIZING = 0x0214
WM_CAPTURECHANGED = 0x0215
WM_MOVING = 0x0216
WM_POWERBROADCAST = 0x0218
WM_DEVICECHANGE = 0x0219
WM_MDICREATE = 0x0220
WM_MDIDESTROY = 0x0221
WM_MDIACTIVATE = 0x0222
WM_MDIRESTORE = 0x0223
WM_MDINEXT = 0x0224
WM_MDIMAXIMIZE = 0x0225
WM_MDITILE = 0x0226
WM_MDICASCADE = 0x0227
WM_MDIICONARRANGE = 0x0228
WM_MDIGETACTIVE = 0x0229
WM_MDIREFRESHMENU = 0x0234
WM_DROPOBJECT = 0x022A
WM_QUERYDROPOBJECT = 0x022B
WM_BEGINDRAG = 0x022C
WM_DRAGLOOP = 0x022D
WM_DRAGSELECT = 0x022E
WM_DRAGMOVE = 0x022F
WM_MDISETMENU = 0x0230
WM_ENTERSIZEMOVE = 0x0231
WM_EXITSIZEMOVE = 0x0232
WM_DROPFILES = 0x0233
WM_IME_SETCONTEXT = 0x0281
WM_IME_NOTIFY = 0x0282
WM_IME_CONTROL = 0x0283
WM_IME_COMPOSITIONFULL = 0x0284
WM_IME_SELECT = 0x0285
WM_IME_CHAR = 0x0286
WM_IME_REQUEST = 0x0288
WM_IME_KEYDOWN = 0x0290
WM_IME_KEYUP = 0x0291
WM_NCMOUSEHOVER = 0x02A0
WM_MOUSEHOVER = 0x02A1
WM_MOUSELEAVE = 0x02A3
WM_NCMOUSELEAVE = 0x02A2
WM_WTSSESSION_CHANGE = 0x02B1
WM_TABLET_FIRST = 0x02c0
WM_TABLET_LAST = 0x02df
WM_CUT = 0x0300
WM_COPY = 0x0301
WM_PASTE = 0x0302
WM_CLEAR = 0x0303
WM_UNDO = 0x0304
WM_RENDERFORMAT = 0x0305
WM_RENDERALLFORMATS = 0x0306
WM_DESTROYCLIPBOARD = 0x0307
WM_DRAWCLIPBOARD = 0x0308
WM_PAINTCLIPBOARD = 0x0309
WM_VSCROLLCLIPBOARD = 0x030A
WM_SIZECLIPBOARD = 0x030B
WM_ASKCBFORMATNAME = 0x030C
WM_CHANGECBCHAIN = 0x030D
WM_HSCROLLCLIPBOARD = 0x030E
WM_QUERYNEWPALETTE = 0x030F
WM_PALETTEISCHANGING = 0x0310
WM_PALETTECHANGED = 0x0311
WM_HOTKEY = 0x0312
WM_PRINT = 0x0317
WM_PRINTCLIENT = 0x0318
WM_APPCOMMAND = 0x0319
WM_THEMECHANGED = 0x031A
WM_CLIPBOARDUPDATE = 0x031D
WM_DWMCOMPOSITIONCHANGED = 0x031E
WM_DWMNCRENDERINGCHANGED = 0x031F
WM_DWMCOLORIZATIONCOLORCHANGED = 0x0320
WM_DWMWINDOWMAXIMIZEDCHANGE = 0x0321
WM_GETTITLEBARINFOEX = 0x033F
WM_HANDHELDFIRST = 0x0358
WM_HANDHELDLAST = 0x035F
WM_AFXFIRST = 0x0360
WM_AFXLAST = 0x037F
WM_PENWINFIRST = 0x0380
WM_PENWINLAST = 0x038F
WM_USER = 0x0400
WM_APP = 0x8000


